{
  Das Copyright liegt alleinig bei
  The owner of the copyright is    Benito van der Zander, alias BeniBela
                                   benibela@aol.com
                                   www.benibela.de

  Diese Unit steht unter der zu letzt verffentlichten General Public Licence (GPL),
  also der mit der hchsten Versionnummer.
  This Unit is distributed under the terms of the least published General Public
  License which has the higgest version number.

  GPL-Header:
     This program is free software; you can redistribute it and/or
     modify it under the terms of the GNU General Public License
     as published by the Free Software Foundation; either version 2
     of the License, or (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}
{  Dies ist ein FileParser der eine einfache Makefile fr mehrere Dateien ausfhrt.
   Eine Makefile entspricht einer ini-Datei mit folgender Struktur:
     [Replace]
       SearchFor1 = ReplaceWith1
       SearchFor2 = ReplaceWith2
       SearchFor3 = ReplaceWith3
     [ReplaceCS]
       SearchFor1 = ReplaceWith1
       SearchFor2 = ReplaceWith2
       SearchFor3 = ReplaceWith3
     [Includes]
        AliasName1 = fileName1
        AliasName2 = fileName2
        AliasName3 = fileName3
     [Files]
       oldfile1 = newfile1
       oldfile2 = newfile2
       oldfile3 = newfile3
     [#fileCode:x1]
        oldfile1 = fileCode1_1
        oldfile2 = fileCode1_2
        oldfile3 = fileCode1_3
     [#FileCode:x2]
        oldfile1 = fileCode2_1
        oldfile2 = fileCode2_2
        oldfile3 = fileCode2_3

  Die Schlssel unter [ReplaceCS] und [ReplaceICS] werden durch ihren jeweiligen Wert ersetzt, und
  zwar wird CS case-sensitive und ohne CS case-insensitive ersetzt.
  Die unter Includes werden durch den Inhalt der angegebenen Datei ersetzt.
  Die Ersetzung erfolgt im uumgekehrte Reihenfolge in den durch oldfile_i angegebenen Dateien, und dann unter newfile_i
  gespeichert.

  Folgende Ersetzungen werden unter Replace vorgenommen:
             Schlssel                           Wert
                '#DoubleSpace' => '  ' (sofern es alleine steht)
                '#SimpleSpace' => ' ' (sofern es alleine steht)
                '#13#10' => #13#10 (sofern es alleine steht)

                                               '#DeleteIt' => '' (sofern alleine)
                                               '#CurrentFileName' => Dateiname der aktuellen Datei (sofern allein)
                                               '#FileCode:x' => Liest den entsprechenden Wert
                                                                aus FileCode:x aus. (sofern allein)
                                               '#FileChangeTime' => Liest die Zeit, wann die Quelldatei zuletzt
                                                                    gendert wurde  FileCode:x aus. (sofern allein)
                                               '\#Gleich' => '='

  Der Parser ist grenteils case-sensitive.
  Es werden nur Dateien erzeugt, deren Quelldateien gendert wurden, dazu wird
  des im Dateisystem registrierte nderugssdatum mit einem unter makefile.time
  gespcichertem verglichen.

}

unit FileParser_u;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, Grids,inifiles, ComCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    CheckBox1: TCheckBox;
    ProgressBar1: TProgressBar;
    procedure beenden1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.beenden1Click(Sender: TObject);
begin
close;
end;

procedure TForm1.Button1Click(Sender: TObject);
type TReplace=record
  old,new:string;
end;
var datei:TStringList;
    includeChanged: boolean;
    makefile,makefiletimes:tinifile;
    dateien,replaced,replacedCS:array of TReplace;
    dateien_sl,replaced_sl,tempFile:TStringList;
    i,j:integer;
begin
  if not fileExists(edit1.text) then begin
    showMessage('File not found '+edit1.text);
    exit;
  end;
  makefile:=tinifile.create(edit1.text);
  makefiletimes:=tinifile.create(edit1.text+'.time');
  try
    datei:=TStringList.create;

    dateien_sl:=TStringList.create;
    replaced_sl:=TStringList.create;
    tempFile:=TStringList.create;
    try

      includeChanged:=(IntToStr(fileage(edit1.text)) <> makefiletimes.ReadString('fileTimes',edit1.text,'-')) //Wurde die Makefile gendert?
                      or (IntToStr(fileage(ParamStr(0))) <> makefiletimes.ReadString('fileTimes',ParamStr(0),'-')); //oder der Parser                                                                                      
      makefile.ReadSectionValues('Replace',replaced_sl);
      SetLength(replaced,replaced_sl.count);
      for i:=0 to replaced_sl.Count-1 do begin
        replaced[i].old:=replaced_sl.Names[i];
        replaced[i].new:=StringReplace(replaced_sl.Values[replaced[i].old],'\#Gleich','=',[rfReplaceAll,rfIgnoreCase]);
        if replaced[i].old='#DoubleSpace' then replaced[i].old:='  '
        else if replaced[i].old='#SimpleSpace' then replaced[i].old:=' '
        else if replaced[i].old='#13#10' then replaced[i].old:=#13#10;

        if replaced[i].new='#DoubleSpace' then replaced[i].new:='  '
        else if replaced[i].new='#DeleteIt' then replaced[i].new:=''
        else if replaced[i].new='#SimpleSpace' then replaced[i].new:=' '
        else if replaced[i].new='#13#10' then replaced[i].new:=#13#10;
      end;


      makefile.ReadSectionValues('Includes',replaced_sl);
      j:=length(replaced);
      SetLength(replaced,{j+ }replaced_sl.count);
      for i:=j to replaced_sl.Count-1 do begin
        replaced[i].old:=replaced_sl.Names[i];
        replaced[i].new:=replaced_sl.Values[replaced[i].old];
        tempFile.LoadFromFile(replaced[i].new);
        if not includeChanged then
          if IntToStr(fileage(replaced[i].new)) <> makefiletimes.ReadString('includeTimes',replaced[i].new,'-') then
            includeChanged:=true;
        makefiletimes.WriteString('includeTimes',replaced[i].new,IntToStr(fileage(replaced[i].new)));
        if replaced[i].old='#DoubleSpace' then replaced[i].old:='  '
        else if replaced[i].old='#SimpleSpace' then replaced[i].old:=' '
        else if replaced[i].old='#13#10' then replaced[i].old:=#13#10;
        replaced[i].new:=tempFile.text;
      end;


      makefile.ReadSectionValues('Replace',replaced_sl);
      SetLength(replacedCS,replaced_sl.count);
      for i:=0 to replaced_sl.Count-1 do begin
        replacedCS[i].old:=replaced_sl.Names[i];
        replacedCS[i].new:=StringReplace(replaced_sl.Values[replacedCS[i].old],'\#Gleich','=',[rfReplaceAll]);
        if replacedCS[i].old='#DoubleSpace' then replacedCS[i].old:='  '
        else if replacedCS[i].old='#SimpleSpace' then replacedCS[i].old:=' '
        else if replacedCS[i].old='#13#10' then replacedCS[i].old:=#13#10;

        if replacedCS[i].new='#DoubleSpace' then replacedCS[i].new:='  '
        else if replacedCS[i].new='#DeleteIt' then replacedCS[i].new:=''
        else if replacedCS[i].new='#SimpleSpace' then replacedCS[i].new:=' '
        else if replacedCS[i].new='#13#10' then replacedCS[i].new:=#13#10;
      end;
      replaced_sl.Free;

      //Dateien laden
      makefile.ReadSectionValues('Files',dateien_sl);
      SetLength(dateien,dateien_sl.count);
      for i:=0 to dateien_sl.Count-1 do begin
        dateien[i].old:=dateien_sl.Names[i];
        dateien[i].new:=dateien_sl.Values[dateien[i].old];
        if not fileExists(dateien[i].old) then begin
          showMessage('File not found '+dateien[i].old);
          dateien[i].old:='';
        end;
      end;

      ProgressBar1.Max:=high(dateien);
      for i:=0 to high(dateien) do begin
        ProgressBar1.Position:=i;
        if (dateien[i].old='') or (dateien[i].new='') or
             ((not includeChanged) and  (FileExists(dateien[i].new)) and
               (IntToStr(fileage(dateien[i].old)) = makefiletimes.ReadString('fileTimes',dateien[i].old,'-'))) then continue;
        datei.LoadFromFile(dateien[i].old);
        for j:=high(replaced) downto 0 do begin//includes first
          if length(replaced[j].new)=0 then
             datei.Text:=StringReplace(datei.Text,replaced[j].old,'',[rfReplaceAll, rfIgnoreCase])
            else
             if StrLComp(@replaced[j].new[1],'#FileChangeTime'#0,15)<>0 then begin
               if StrLComp(@replaced[j].new[1],'#CurrentFileName'#0,16)<>0 then begin
                 if StrLComp(@replaced[j].new[1],'#FileCode:'#0,9)=0 then
                   datei.Text:=StringReplace(datei.Text,replaced[j].old,makefile.ReadString(replaced[j].new,dateien[i].old,'!- not found -!'),[rfReplaceAll, rfIgnoreCase])
                  else
                   datei.Text:=StringReplace(datei.Text,replaced[j].old,replaced[j].new,[rfReplaceAll, rfIgnoreCase])
               end else
                 datei.Text:=StringReplace(datei.Text,replaced[j].old,ExtractFileName(dateien[i].old),[rfReplaceAll, rfIgnoreCase])
            end else
              datei.Text:=StringReplace(datei.Text,replaced[j].old,DateTimeToStr( FileDateToDateTime(FileAge(dateien[i].old))),[rfReplaceAll, rfIgnoreCase]);
        end;
        for j:=high(replacedCS) downto 0 do begin//includes first
          if length(replaced[j].new)=0 then
             datei.Text:=StringReplace(datei.Text,replaced[j].old,'',[rfReplaceAll])
            else
              if StrLComp(@replacedCS[j].new[1],'#FileChangeTime'#0,15)<>0 then begin
                if StrLComp(@replacedCS[j].new[1],'#CurrentFileName'#0,16)<>0 then begin
                  if StrLComp(@replacedCS[j].new[1],'#FileCode:'#0,9)=0 then
                    datei.Text:=StringReplace(datei.Text,replacedCS[j].old,makefile.ReadString(replacedCS[j].new,dateien[i].old,'!- not found -!'),[rfReplaceAll])
                   else
                    datei.Text:=StringReplace(datei.Text,replacedCS[j].old,replacedCS[j].new,[rfReplaceAll])
               end else
                datei.Text:=StringReplace(datei.Text,replacedCS[j].old,ExtractFileName(dateien[i].old),[rfReplaceAll])
            end else
              datei.Text:=StringReplace(datei.Text,replacedCS[j].old,DateTimeToStr( FileDateToDateTime(FileAge(dateien[i].old))),[rfReplaceAll])
        end;
        datei.SaveToFile(dateien[i].new);
      end;
      //Zeitangaben aktualisieren
      for i:=0 to dateien_sl.Count-1 do
        makefiletimes.WriteString('fileTimes',dateien[i].old,IntToStr(fileage(dateien[i].old)));
      makefiletimes.WriteString('fileTimes',edit1.text,IntToStr(fileage(edit1.text)));
      makefiletimes.WriteString('fileTimes',ParamStr(0),IntToStr(fileage(ParamStr(0))));
      dateien_sl.free;
    finally
      tempFile.free;
      datei.free;
    end;
  finally
    makefiletimes.free;
    makefile.free;
  end;
  showmessage('fertig');
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked then FormStyle:=fsStayOnTop
  else FormStyle:=fsNormal;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 close;
end;

end.
